-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["HUNTER"] = {}
lib.classes["HUNTER"][4] = function ()

	cfg.spells={}
	lib.AddSpell(Heddframe,cfg.spells,"melee",{6603}) -- Melee
	lib.AddSpell(Heddframe,cfg.spells,"as",{3044}) -- Arcane Shot
	lib.AddSpell(Heddframe,cfg.spells,"ss",{56641}) -- Steady Shot	
				
	cfg.auras={}
	
	local plist = {}
	table.insert(plist,"as")
	table.insert(plist,"ss")
	table.insert(plist,"end")

	cfg.plist=plist

	cfg.case = {}
	cfg.case = {
		["end"] = function ()
			if cfg.cmintime ~= cfg.maxmintime then
			return nil end
		end,
	}

	return true
end

lib.classes["HUNTER"][3] = function ()

	cfg.spells={}
	lib.AddSpell(Heddframe,cfg.spells,"melee",{6603}) -- Melee
	lib.AddSpell(Heddframe,cfg.spells,"as",{3044}) -- Arcane Shot
	lib.AddSpell(Heddframe,cfg.spells,"ss",{56641}) -- Steady Shot	
	lib.AddSpell(Heddframe,cfg.spells,"es",{53301}) -- Explosive Shot
	lib.AddSpell(Heddframe,cfg.spells,"sting",{1978}) -- Serpent Sting
	lib.AddSpell(Heddframe,cfg.spells,"mark",{1130}) -- Hunter's Mark
	lib.AddSpell(Heddframe,cfg.spells,"ks",{53351}) -- Kill Shot
	lib.AddSpell(Heddframe,cfg.spells,"kc",{34026}) -- Kill Command
	lib.AddSpell(Heddframe,cfg.spells,"ms",{2643}) -- Multi-Shot
	lib.AddSpell(Heddframe,cfg.spells,"trap",{77769}) -- Trap Launcher
	lib.AddSpell(Heddframe,cfg.spells,"et",{13813}) -- Explosive Trap
	
	cfg.auras={}
	lib.AddAura(cfg.auras,"es",53301,"debuff","target") -- Explosive Shot
	lib.AddAura(cfg.auras,"lnl",56453,"buff","player") -- Lock and Load
	lib.AddAura(cfg.auras,"Sting",1978,"debuff","target") -- Serpent Sting
	lib.AddAura(cfg.auras,"Mark",1130,"debuff","target","any") -- Hunter's Mark
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ks")
	table.insert(cfg.plistdps,"es_lnl")
--	table.insert(cfg.plistdps,"mark")
	table.insert(cfg.plistdps,"sting")
	table.insert(cfg.plistdps,"es")
	table.insert(cfg.plistdps,"kc_es")
	table.insert(cfg.plistdps,"as_es")
	table.insert(cfg.plistdps,"trap")
	table.insert(cfg.plistdps,"as")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ks")
	table.insert(cfg.plistaoe,"es_lnl")
	table.insert(cfg.plistaoe,"trap")
	table.insert(cfg.plistaoe,"ms")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["trap"] = function()
			if cfg.spells["trap"] and cfg.power>=cfg.spells["trap"].powerCost then
				return lib.SimpleCDCheck("et")
			end
			return nil
		end,
		["mark"] = function()
			local t = lib.GetAura({"Mark"})
			if t<3 then
				return lib.SimpleCDCheck("mark")
			end
			return nil
		end,
		["sting"] = function()
			local t = lib.GetAura({"Sting"})
			if t<3 then
				return lib.SimpleCDCheck("sting")
			end
			return nil
		end,
		["es"] = function()
			if lib.GetAura({"es"})<1 then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
		["es_lnl"] = function()
			if lib.GetAura({"lnl"})>0 and lib.GetAura({"es"})<1 then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
		["kc_es"] = function()
			if lib.GetAura({"es"})>0 and lib.GetAura({"lnl"})>0 then
				return lib.SimpleCDCheck("kc")
			end
			return nil
		end,
		["as_es"] = function()
			if lib.GetAura({"es"})>0 and lib.GetAura({"Sting"})>6 and lib.GetAura({"lnl"})>0 then
				return lib.SimpleCDCheck("as")
			end
			return nil
		end,
		["as"] = function()
			if cfg.power > 70 then
				lib.SimpleCDCheck("as")
			end
			return nil
		end,
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}

	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		print(cfg.mode)
	end
	
	return true
end

lib.classevents["HUNTER"] = function()
	lib.rangecheck=function()
		if lib.inrange("as") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonupdate = function()
		lib.rangecheck()
	end
	
	cfg.onpower=true
	cfg.onhealth=true
	cfg.onupdate=true
end